#!/usr/bin/python3

from utils import *
from download_page import download

# portable code to get filename
import os
platform = os.path.basename(__file__)
if platform.endswith(".py"):
	platform = platform[:(-3)]

def extract_from_url (url, verbosity):
	# split into domain and path
	index = url.find("/",url.find("//")+2)
	domain = url[:index]
	path = url[index:]

	# get username
	index = path.find("/",2)
	if index > -1:
		username = path[1:index]
	else:
		username = path[1:]

	if len(username) > 0 and username[0] == "@":
		return domain + "/$/rss/" + username

def extract_from_page (page, verbosity):
	# for example, https://odysee.com/the-ultimate-guide-to-using-matrix!:4d33438b778316b59aa174264d9eb3ec347fed53
	# is canonically https://odysee.com/@techlore:3/the-ultimate-guide-to-using-matrix!#4
	canonical_url = search (page, '<link rel="canonical" content="', '"/>')
	if canonical_url is None:
		canonical_url = search (page, '<meta property="og:url" content="', '"/>')

	if not canonical_url is None:
		return extract_from_url (canonical_url, verbosity)

def extract (url, page=None, network=False, verbosity=3, args={}):
	feed = extract_from_url (url, verbosity)
	if not feed is None:
		return feed
	else:
		notify ("Unable to get feed from URL alone", verbosity, platform)
		if network:
			page = download (platform, url, args, verbosity)
			feed = extract_from_page (page, verbosity)
			if not feed is None:
				return feed
